import { FormGroup, ReactiveFormsModule, FormArray, FormControl } from '@angular/forms';
import { CommonModule } from '@angular/common';
import { Input, Component, ViewContainerRef, ContentChildren, EventEmitter, Output, ComponentFactoryResolver, ChangeDetectorRef, NgModule } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/form-type/abstract-type.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @abstract
 * @template T
 */
class AbstractType {
    /**
     * @param {?} options
     */
    constructor(options) {
        this.options = options;
    }
    /**
     * @return {?}
     */
    get asyncValidators() {
        return null;
    }
    /**
     * @return {?}
     */
    get validators() {
        return null;
    }
    /**
     * @return {?}
     */
    get updateOn() {
        return null;
    }
    /**
     * @return {?}
     */
    get disabled() {
        return false;
    }
    /**
     * @return {?}
     */
    get controlOptions() {
        return {
            asyncValidators: this.asyncValidators,
            validators: this.validators,
            updateOn: this.updateOn
        };
    }
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/form-type/abstract-collection-type.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @abstract
 * @template TConfig, T
 */
class AbstractCollectionType extends AbstractType {
    /**
     * @param {?} childType
     * @param {?} options
     */
    constructor(childType, options) {
        super(options);
        this.childType = childType;
        this.fieldInstance = new this.childType(this.options.entrySettings);
    }
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/abstract-form-field/abstract-form-field.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @abstract
 * @template T
 */
class AbstractFormFieldComponent {
}
AbstractFormFieldComponent.propDecorators = {
    formGroup: [{ type: Input }],
    element: [{ type: Input }],
    index: [{ type: Input }],
    fieldType: [{ type: Input }],
    path: [{ type: Input }],
    slots: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * Generated from: lib/form-type/abstract-group-type.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @abstract
 * @template T
 */
class AbstractGroupType extends AbstractType {
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/abstraction/init-handler.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @template T
 */
class InitHandler {
    /**
     * @param {?} instance
     */
    constructor(instance) {
        this.instance = instance;
        this.propIsInitialized = false;
    }
    /**
     * @return {?}
     */
    get isInitialized() {
        return this.propIsInitialized;
    }
    /**
     * @param {?} value
     * @return {?}
     */
    setIsInitialized(value) {
        /** @type {?} */
        const isGroupOrArray = 'controls' in this.instance;
        /** @type {?} */
        const ripple = this.propIsInitialized !== value;
        this.propIsInitialized = value;
        if (isGroupOrArray) {
            ((/** @type {?} */ ((/** @type {?} */ (this.instance)))))._setUpControls();
        }
        ((/** @type {?} */ (this.instance))).updateValueAndValidity({ onlySelf: false, emitEvent: true });
        if (ripple && isGroupOrArray) {
            /** @type {?} */
            const childControls = ((/** @type {?} */ ((/** @type {?} */ (this.instance))))).controls;
            Object.keys(childControls)
                .forEach((/**
             * @param {?} k
             * @return {?}
             */
            (k) => childControls[k].initHandler.setIsInitialized(value)));
        }
    }
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/abstraction/form-array.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class FormArray$1 extends FormArray {
    constructor() {
        super(...arguments);
        this.initHandler = new InitHandler(this);
    }
    /**
     * @param {?=} opts
     * @return {?}
     */
    updateValueAndValidity(opts) {
        if (this.initHandler && this.initHandler.isInitialized) {
            super.updateValueAndValidity(opts);
        }
    }
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/abstraction/form-control.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class FormControl$1 extends FormControl {
    constructor() {
        super(...arguments);
        this.initHandler = new InitHandler(this);
    }
    /**
     * @param {?=} opts
     * @return {?}
     */
    updateValueAndValidity(opts) {
        if (this.initHandler && this.initHandler.isInitialized) {
            super.updateValueAndValidity(opts);
        }
    }
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/abstraction/form-group.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class FormGroup$1 extends FormGroup {
    constructor() {
        super(...arguments);
        this.initHandler = new InitHandler(this);
    }
    /**
     * @param {?=} opts
     * @return {?}
     */
    updateValueAndValidity(opts) {
        if (this.initHandler && this.initHandler.isInitialized) {
            super.updateValueAndValidity(opts);
        }
    }
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/abstraction/index.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: lib/model-handler.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ModelHandler {
    /**
     * @param {?} model
     * @param {?} builderInstance
     * @return {?}
     */
    static build(model, builderInstance) {
        /** @type {?} */
        const group = new FormGroup$1({});
        this.handleModel(model, group, builderInstance);
        return group;
    }
    /**
     * @private
     * @param {?} model
     * @param {?} group
     * @param {?} builderInstance
     * @return {?}
     */
    static handleModel(model, group, builderInstance) {
        Object.keys(model).forEach((/**
         * @param {?} name
         * @return {?}
         */
        (name) => {
            /** @type {?} */
            const field = model[name];
            if (field) {
                /** @type {?} */
                const control = ModelHandler.handleField(field, builderInstance);
                control.setParent(group);
                if (field.disabled) {
                    control.disable();
                }
                group.addControl(name, control);
                if (field.builderInstance == null && builderInstance) {
                    field.builderInstance = builderInstance;
                }
            }
        }));
    }
    /**
     * @private
     * @param {?} field
     * @param {?} builderInstance
     * @return {?}
     */
    static handleField(field, builderInstance) {
        /** @type {?} */
        let component;
        if (field instanceof AbstractCollectionType) {
            component = new FormArray$1([], field.controlOptions);
            ModelHandler.handleArray((/** @type {?} */ (field)), (/** @type {?} */ (component)), builderInstance);
        }
        else if (field instanceof AbstractGroupType) {
            component = new FormGroup$1({}, field.controlOptions);
            ModelHandler.handleModel(field.options.model, (/** @type {?} */ (component)), builderInstance);
        }
        else {
            component = new FormControl$1({ value: null, disabled: field.disabled }, field.controlOptions);
        }
        return component;
    }
    /**
     * @private
     * @param {?} field
     * @param {?} array
     * @param {?} builderInstance
     * @return {?}
     */
    static handleArray(field, array, builderInstance) {
        array.push(ModelHandler.handleField(field.fieldInstance, builderInstance));
    }
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/abstract-collection-form-field/abstract-collection-form-field.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @abstract
 */
class AbstractCollectionFormFieldComponent extends AbstractFormFieldComponent {
    /**
     * @param {?} index
     * @return {?}
     */
    removeEntry(index) {
        ((/** @type {?} */ (this.element))).removeAt(index);
    }
    /**
     * @return {?}
     */
    addEntry() {
        if (this.fieldType.fieldInstance instanceof AbstractGroupType) {
            /** @type {?} */
            const field = ModelHandler.build(this.fieldType.fieldInstance.options.model, this.fieldType.builderInstance);
            field.setParent((/** @type {?} */ (this.element)));
            ((/** @type {?} */ (this.element))).controls.push(field);
        }
        else if (this.fieldType.fieldInstance instanceof AbstractCollectionType) {
            ((/** @type {?} */ (this.element))).controls.push(new FormArray$1([], this.fieldType.fieldInstance.controlOptions));
        }
        else {
            ((/** @type {?} */ (this.element))).controls.push(new FormControl$1(null, this.fieldType.fieldInstance.controlOptions));
        }
    }
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/abstract-group-form-field/abstract-group-form-field.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @abstract
 * @template FormType
 */
class AbstractGroupFormField extends AbstractFormFieldComponent {
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/form-slot/form-slot.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class FormSlotComponent {
    /**
     * @param {?} viewRef
     */
    constructor(viewRef) {
        this.viewRef = viewRef;
    }
}
FormSlotComponent.decorators = [
    { type: Component, args: [{
                selector: 'mw-form-slot',
                template: ''
            }] }
];
/** @nocollapse */
FormSlotComponent.ctorParameters = () => [
    { type: ViewContainerRef }
];
FormSlotComponent.propDecorators = {
    fieldName: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * Generated from: lib/form-builder/form-builder.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class FormBuilderComponent {
    constructor() {
        this.onSubmit = new EventEmitter();
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        if (this.group == null) {
            this.rebuildForm();
        }
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    ngOnChanges(changes) {
        if ('formModel' in changes && changes.formModel.currentValue) {
            this.rebuildForm();
        }
        if ('formData' in changes && changes.formData.currentValue) {
            if (!('formModel' in changes)) {
                this.initializeCollectionFields(this.group, this.formModel, this.formData);
            }
            if (this.group) {
                this.group.patchValue(this.formData);
            }
        }
    }
    /**
     * @return {?}
     */
    rebuildForm() {
        /** @type {?} */
        let res = {};
        if (this.group) {
            res = Object.assign({}, this.group.value);
        }
        else if (this.formData) {
            res = Object.assign({}, this.formData);
        }
        this.group = ModelHandler.build(this.formModel, this);
        this.initializeCollectionFields(this.group, this.formModel, res);
        if (this.group) {
            this.group.patchValue(res);
        }
    }
    /**
     * @private
     * @param {?} group
     * @param {?} model
     * @param {?} data
     * @return {?}
     */
    initializeCollectionFields(group, model, data) {
        Object.keys(model).forEach((/**
         * @param {?} name
         * @return {?}
         */
        (name) => {
            /** @type {?} */
            const formType = model[name];
            /** @type {?} */
            const childData = (data && name in data) ? data[name] : null;
            /** @type {?} */
            const control = group.get(name);
            if (formType instanceof AbstractGroupType) {
                this.initializeCollectionFields((/** @type {?} */ (control)), ((/** @type {?} */ (formType))).options.model, childData);
            }
            else if (formType instanceof AbstractCollectionType) {
                this.initializeCollectionField(formType, (/** @type {?} */ (control)), childData);
            }
        }));
    }
    /**
     * @private
     * @param {?} collection
     * @param {?} array
     * @param {?=} data
     * @return {?}
     */
    initializeCollectionField(collection, array, data) {
        /** @type {?} */
        const numberOfEntries = Array.isArray(data) ? data.length : 0;
        [...new Array(array.controls.length).keys()].forEach((/**
         * @param {?} n
         * @return {?}
         */
        (n) => array.removeAt(n)));
        if (numberOfEntries === 0) {
            return;
        }
        /** @type {?} */
        const fieldInstance = collection.fieldInstance;
        /** @type {?} */
        const isGroup = fieldInstance instanceof AbstractGroupType;
        /** @type {?} */
        const isCollection = !isGroup && fieldInstance instanceof AbstractCollectionType;
        /** @type {?} */
        const isFormField = !isCollection && fieldInstance instanceof AbstractType;
        for (let i = 0; i < numberOfEntries; i++) {
            if (isGroup) {
                /** @type {?} */
                const childModel = ((/** @type {?} */ (fieldInstance))).options.model;
                /** @type {?} */
                const childFormGroup = ModelHandler.build(childModel, this);
                childFormGroup.setParent(array);
                if (fieldInstance.disabled) {
                    childFormGroup.disable();
                }
                this.initializeCollectionFields(childFormGroup, childModel, data[i]);
                array.controls.push(childFormGroup);
            }
            else if (isCollection) {
                /** @type {?} */
                const childArray = new FormArray$1([], fieldInstance.controlOptions);
                childArray.setParent(array);
                if (fieldInstance.disabled) {
                    childArray.disable();
                }
                this.initializeCollectionField((/** @type {?} */ (fieldInstance)), childArray, data[i]);
                array.controls.push(childArray);
            }
            else if (isFormField) {
                array.controls.push(new FormControl$1({ value: null, disabled: fieldInstance.disabled }, fieldInstance.controlOptions));
            }
        }
    }
    /**
     * @return {?}
     */
    submit() {
        Object.keys(this.group.controls).forEach((/**
         * @param {?} field
         * @return {?}
         */
        (field) => {
            /** @type {?} */
            const control = this.group.get(field);
            control.markAsDirty();
            control.updateValueAndValidity();
        }));
        if (!this.group.valid) {
            return;
        }
        this.onSubmit.emit(this.group.value);
        return this.group.value;
    }
    /**
     * @param {?=} group
     * @return {?}
     */
    getErrors(group) {
        /** @type {?} */
        const errors = group instanceof FormArray$1 ? [] : {};
        if (group == null) {
            group = this.group;
        }
        /** @type {?} */
        let idx = 0;
        Object.keys(group.controls).forEach((/**
         * @param {?} name
         * @return {?}
         */
        (name) => {
            idx++;
            /** @type {?} */
            const control = group.get(name);
            if (control instanceof FormArray$1 || control instanceof FormGroup$1) {
                /** @type {?} */
                const tmpErrors = this.getErrors((/** @type {?} */ (control)));
                if (tmpErrors) {
                    errors[name] = tmpErrors;
                }
            }
            else if (control instanceof FormControl$1) {
                if (control.errors == null) {
                    return null;
                }
                if (group instanceof FormArray$1) {
                    ((/** @type {?} */ (errors)))[idx] = control.errors;
                }
                else {
                    errors[name] = control.errors;
                }
            }
        }));
        return (group instanceof FormGroup$1 && Object.keys(errors).length === 0)
            || Array.isArray(errors) && errors.length === 0 ? null : errors;
    }
}
FormBuilderComponent.decorators = [
    { type: Component, args: [{
                selector: 'mw-form-builder',
                template: `
    <ng-content></ng-content>
    <form [formGroup]="group" (ngSubmit)="submit()" #form>
      <mw-form-group #fromGroup [element]="group" [formGroup]="group" [model]="formModel" [slots]="slots" [isRootGroup]="true">
      </mw-form-group>
    </form>
  `
            }] }
];
FormBuilderComponent.propDecorators = {
    formModel: [{ type: Input }],
    formData: [{ type: Input }],
    onSubmit: [{ type: Output }],
    slots: [{ type: ContentChildren, args: [FormSlotComponent, { descendants: true },] }]
};

/**
 * @fileoverview added by tsickle
 * Generated from: lib/form-field/form-field.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class FormFieldComponent extends AbstractFormFieldComponent {
    /**
     * @param {?} viewRef
     * @param {?} cfr
     */
    constructor(viewRef, cfr) {
        super();
        this.viewRef = viewRef;
        this.cfr = cfr;
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    ngOnChanges(changes) {
        this.render();
    }
    /**
     * @return {?}
     */
    render() {
        if (this.fieldType == null) {
            return;
        }
        this.viewRef.clear();
        /** @type {?} */
        const factory = this.cfr.resolveComponentFactory(this.fieldType.component);
        /** @type {?} */
        const component = this.viewRef.createComponent(factory);
        /** @type {?} */
        const isGroup = this.fieldType instanceof AbstractGroupType;
        ((/** @type {?} */ (component.instance))).formGroup = isGroup ? (/** @type {?} */ (this.element)) : this.formGroup;
        ((/** @type {?} */ (component.instance))).element = this.element;
        ((/** @type {?} */ (component.instance))).fieldType = this.fieldType;
        ((/** @type {?} */ (component.instance))).slots = this.slots;
        ((/** @type {?} */ (component.instance))).path = this.path;
        ((/** @type {?} */ (component.instance))).index = this.index;
        component.changeDetectorRef.detectChanges();
    }
}
FormFieldComponent.decorators = [
    { type: Component, args: [{
                selector: 'mw-form-field',
                template: ''
            }] }
];
/** @nocollapse */
FormFieldComponent.ctorParameters = () => [
    { type: ViewContainerRef },
    { type: ComponentFactoryResolver }
];

/**
 * @fileoverview added by tsickle
 * Generated from: lib/form-group/form-group.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class FormGroupComponent extends AbstractFormFieldComponent {
    /**
     * @param {?} cfr
     * @param {?} cdr
     */
    constructor(cfr, cdr) {
        super();
        this.cfr = cfr;
        this.cdr = cdr;
        this.isRootGroup = false;
        this.renderTargets = {};
        this.initializeTimeoutHandle = null;
        this.orderAsGiven = (/**
         * @return {?}
         */
        () => 1);
    }
    /**
     * @return {?}
     */
    get groupPath() {
        return (this.path == null || this.path.trim() === '')
            ? ''
            : this.path;
    }
    /**
     * @return {?}
     */
    get indexFromParent() {
        if (this.index == null) {
            return null;
        }
        /** @type {?} */
        let p = this.element;
        do {
            p = p.parent;
            if (p instanceof FormArray$1) {
                return this.index;
            }
        } while (p && p.parent && !(parent instanceof FormControl$1));
        return null;
    }
    /**
     * @return {?}
     */
    ngAfterViewInit() {
        if (this.mySlots) {
            this.renderElementsInSlots();
            this.cdr.detectChanges();
        }
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    ngOnChanges(changes) {
        /** @type {?} */
        let wasRendered = false;
        if ('slots' in changes && changes.slots.currentValue) {
            this.renderElementsInSlots();
            wasRendered = true;
        }
        if (!wasRendered && 'mySlots' in changes && changes.mySlots.currentValue) {
            this.renderElementsInSlots();
        }
    }
    /**
     * @private
     * @return {?}
     */
    renderElementsInSlots() {
        if (this.slots || this.mySlots) {
            this.createRenderTargets();
            Object.keys(this.renderTargets).map((/**
             * @param {?} name
             * @return {?}
             */
            (name) => {
                if (!(name in this.renderTargets)) {
                    return;
                }
                this.renderTargets[name].viewRef.clear();
                /** @type {?} */
                const factory = this.cfr.resolveComponentFactory(FormFieldComponent);
                /** @type {?} */
                const target = this.renderTargets[name].viewRef.createComponent(factory);
                target.instance.formGroup = this.formGroup;
                target.instance.element = this.formGroup.get(name);
                target.instance.slots = this.slots;
                target.instance.path = this.pathForField(name);
                target.instance.fieldType = this.model[name];
                target.instance.index = this.indexFromParent;
                target.instance.render();
            }));
            if (this.isRootGroup) {
                if (this.initializeTimeoutHandle) {
                    window.clearTimeout(this.initializeTimeoutHandle);
                }
                this.initializeTimeoutHandle = window.setTimeout((/**
                 * @return {?}
                 */
                () => {
                    ((/** @type {?} */ (this.element))).initHandler.setIsInitialized(true);
                    this.cdr.detectChanges();
                }), 5);
            }
        }
    }
    /**
     * @private
     * @return {?}
     */
    createRenderTargets() {
        /** @type {?} */
        const groupPath = this.groupPath;
        if (this.slots) {
            this.slots.toArray().forEach((/**
             * @param {?} slot
             * @return {?}
             */
            (slot) => {
                if (slot.fieldName.substr(0, groupPath.length) !== groupPath) {
                    return;
                }
                /** @type {?} */
                let name = slot.fieldName.substr(groupPath.length, slot.fieldName.length - groupPath.length);
                if (name.startsWith('.')) {
                    name = name.substr(1);
                }
                if (name.indexOf('.') < 0 && name !== '') {
                    this.renderTargets[name] = slot;
                }
            }));
        }
        if (this.mySlots) {
            this.mySlots.toArray().forEach((/**
             * @param {?} slot
             * @return {?}
             */
            (slot) => {
                this.renderTargets[slot.fieldName] = slot;
            }));
        }
    }
    /**
     * @param {?} fieldName
     * @return {?}
     */
    pathForField(fieldName) {
        return (this.groupPath === '')
            ? fieldName
            : this.path + '.' + fieldName;
    }
}
FormGroupComponent.decorators = [
    { type: Component, args: [{
                selector: 'mw-form-group',
                template: `
    <ng-content></ng-content>
    <ng-container *ngFor="let field of (model | keyvalue:orderAsGiven)">
      <mw-form-field *ngIf="renderTargets[field.key] == null"
                     [formGroup]="element"
                     [element]="element.get(field.key)"
                     [fieldType]="field.value"
                     [path]="pathForField(field.key)"
                     [index]="indexFromParent"
                     [slots]="slots">
      </mw-form-field>
    </ng-container>
  `
            }] }
];
/** @nocollapse */
FormGroupComponent.ctorParameters = () => [
    { type: ComponentFactoryResolver },
    { type: ChangeDetectorRef }
];
FormGroupComponent.propDecorators = {
    isRootGroup: [{ type: Input }],
    model: [{ type: Input }],
    mySlots: [{ type: ContentChildren, args: [FormSlotComponent, { descendants: true },] }]
};

/**
 * @fileoverview added by tsickle
 * Generated from: lib/form-builder.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class FormBuilderModule {
}
FormBuilderModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    FormBuilderComponent,
                    FormGroupComponent,
                    FormFieldComponent,
                    FormSlotComponent,
                ],
                entryComponents: [
                    FormFieldComponent,
                    FormGroupComponent,
                ],
                imports: [
                    ReactiveFormsModule,
                    CommonModule,
                ],
                exports: [
                    FormBuilderComponent,
                    FormGroupComponent,
                    FormFieldComponent,
                    FormSlotComponent,
                ],
            },] }
];

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: mw-form-builder.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { AbstractCollectionFormFieldComponent, AbstractFormFieldComponent, AbstractGroupFormField, FormBuilderComponent, FormFieldComponent, FormSlotComponent, FormBuilderModule, AbstractType, AbstractGroupType, AbstractCollectionType, FormGroupComponent as ɵa };

//# sourceMappingURL=mw-form-builder.js.map