import { FormGroup, ReactiveFormsModule, FormControl, FormArray } from '@angular/forms';
import { CommonModule } from '@angular/common';
import { __extends, __spread } from 'tslib';
import { Input, Component, ViewContainerRef, ContentChildren, EventEmitter, Output, ComponentFactoryResolver, ChangeDetectorRef, NgModule } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/form-type/abstract-type.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @abstract
 * @template T
 */
var  /**
 * @abstract
 * @template T
 */
AbstractType = /** @class */ (function () {
    function AbstractType(options) {
        this.options = options;
    }
    Object.defineProperty(AbstractType.prototype, "asyncValidators", {
        get: /**
         * @return {?}
         */
        function () {
            return null;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AbstractType.prototype, "validators", {
        get: /**
         * @return {?}
         */
        function () {
            return null;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AbstractType.prototype, "updateOn", {
        get: /**
         * @return {?}
         */
        function () {
            return null;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AbstractType.prototype, "disabled", {
        get: /**
         * @return {?}
         */
        function () {
            return false;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AbstractType.prototype, "controlOptions", {
        get: /**
         * @return {?}
         */
        function () {
            return {
                asyncValidators: this.asyncValidators,
                validators: this.validators,
                updateOn: this.updateOn
            };
        },
        enumerable: true,
        configurable: true
    });
    return AbstractType;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: lib/form-type/abstract-collection-type.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @abstract
 * @template TConfig, T
 */
var  /**
 * @abstract
 * @template TConfig, T
 */
AbstractCollectionType = /** @class */ (function (_super) {
    __extends(AbstractCollectionType, _super);
    function AbstractCollectionType(childType, options) {
        var _this = _super.call(this, options) || this;
        _this.childType = childType;
        _this.fieldInstance = new _this.childType(_this.options.entrySettings);
        return _this;
    }
    return AbstractCollectionType;
}(AbstractType));

/**
 * @fileoverview added by tsickle
 * Generated from: lib/abstract-form-field/abstract-form-field.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @abstract
 * @template T
 */
var AbstractFormFieldComponent = /** @class */ (function () {
    function AbstractFormFieldComponent() {
    }
    AbstractFormFieldComponent.propDecorators = {
        formGroup: [{ type: Input }],
        element: [{ type: Input }],
        index: [{ type: Input }],
        fieldType: [{ type: Input }],
        path: [{ type: Input }],
        slots: [{ type: Input }]
    };
    return AbstractFormFieldComponent;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: lib/form-type/abstract-group-type.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @abstract
 * @template T
 */
var  /**
 * @abstract
 * @template T
 */
AbstractGroupType = /** @class */ (function (_super) {
    __extends(AbstractGroupType, _super);
    function AbstractGroupType() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return AbstractGroupType;
}(AbstractType));

/**
 * @fileoverview added by tsickle
 * Generated from: lib/abstraction/init-handler.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @template T
 */
var /**
 * @template T
 */
InitHandler = /** @class */ (function () {
    function InitHandler(instance) {
        this.instance = instance;
        this.propIsInitialized = false;
    }
    Object.defineProperty(InitHandler.prototype, "isInitialized", {
        get: /**
         * @return {?}
         */
        function () {
            return this.propIsInitialized;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} value
     * @return {?}
     */
    InitHandler.prototype.setIsInitialized = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        /** @type {?} */
        var isGroupOrArray = 'controls' in this.instance;
        /** @type {?} */
        var ripple = this.propIsInitialized !== value;
        this.propIsInitialized = value;
        if (isGroupOrArray) {
            ((/** @type {?} */ ((/** @type {?} */ (this.instance)))))._setUpControls();
        }
        ((/** @type {?} */ (this.instance))).updateValueAndValidity({ onlySelf: false, emitEvent: true });
        if (ripple && isGroupOrArray) {
            /** @type {?} */
            var childControls_1 = ((/** @type {?} */ ((/** @type {?} */ (this.instance))))).controls;
            Object.keys(childControls_1)
                .forEach((/**
             * @param {?} k
             * @return {?}
             */
            function (k) { return childControls_1[k].initHandler.setIsInitialized(value); }));
        }
    };
    return InitHandler;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: lib/abstraction/form-array.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var FormArray$1 = /** @class */ (function (_super) {
    __extends(FormArray$$1, _super);
    function FormArray$$1() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.initHandler = new InitHandler(_this);
        return _this;
    }
    /**
     * @param {?=} opts
     * @return {?}
     */
    FormArray$$1.prototype.updateValueAndValidity = /**
     * @param {?=} opts
     * @return {?}
     */
    function (opts) {
        if (this.initHandler && this.initHandler.isInitialized) {
            _super.prototype.updateValueAndValidity.call(this, opts);
        }
    };
    return FormArray$$1;
}(FormArray));

/**
 * @fileoverview added by tsickle
 * Generated from: lib/abstraction/form-control.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var FormControl$1 = /** @class */ (function (_super) {
    __extends(FormControl$$1, _super);
    function FormControl$$1() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.initHandler = new InitHandler(_this);
        return _this;
    }
    /**
     * @param {?=} opts
     * @return {?}
     */
    FormControl$$1.prototype.updateValueAndValidity = /**
     * @param {?=} opts
     * @return {?}
     */
    function (opts) {
        if (this.initHandler && this.initHandler.isInitialized) {
            _super.prototype.updateValueAndValidity.call(this, opts);
        }
    };
    return FormControl$$1;
}(FormControl));

/**
 * @fileoverview added by tsickle
 * Generated from: lib/abstraction/form-group.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var FormGroup$1 = /** @class */ (function (_super) {
    __extends(FormGroup$$1, _super);
    function FormGroup$$1() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.initHandler = new InitHandler(_this);
        return _this;
    }
    /**
     * @param {?=} opts
     * @return {?}
     */
    FormGroup$$1.prototype.updateValueAndValidity = /**
     * @param {?=} opts
     * @return {?}
     */
    function (opts) {
        if (this.initHandler && this.initHandler.isInitialized) {
            _super.prototype.updateValueAndValidity.call(this, opts);
        }
    };
    return FormGroup$$1;
}(FormGroup));

/**
 * @fileoverview added by tsickle
 * Generated from: lib/abstraction/index.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: lib/model-handler.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ModelHandler = /** @class */ (function () {
    function ModelHandler() {
    }
    /**
     * @param {?} model
     * @param {?} builderInstance
     * @return {?}
     */
    ModelHandler.build = /**
     * @param {?} model
     * @param {?} builderInstance
     * @return {?}
     */
    function (model, builderInstance) {
        /** @type {?} */
        var group = new FormGroup$1({});
        this.handleModel(model, group, builderInstance);
        return group;
    };
    /**
     * @private
     * @param {?} model
     * @param {?} group
     * @param {?} builderInstance
     * @return {?}
     */
    ModelHandler.handleModel = /**
     * @private
     * @param {?} model
     * @param {?} group
     * @param {?} builderInstance
     * @return {?}
     */
    function (model, group, builderInstance) {
        Object.keys(model).forEach((/**
         * @param {?} name
         * @return {?}
         */
        function (name) {
            /** @type {?} */
            var field = model[name];
            if (field) {
                /** @type {?} */
                var control = ModelHandler.handleField(field, builderInstance);
                control.setParent(group);
                if (field.disabled) {
                    control.disable();
                }
                group.addControl(name, control);
                if (field.builderInstance == null && builderInstance) {
                    field.builderInstance = builderInstance;
                }
            }
        }));
    };
    /**
     * @private
     * @param {?} field
     * @param {?} builderInstance
     * @return {?}
     */
    ModelHandler.handleField = /**
     * @private
     * @param {?} field
     * @param {?} builderInstance
     * @return {?}
     */
    function (field, builderInstance) {
        /** @type {?} */
        var component;
        if (field instanceof AbstractCollectionType) {
            component = new FormArray$1([], field.controlOptions);
            ModelHandler.handleArray((/** @type {?} */ (field)), (/** @type {?} */ (component)), builderInstance);
        }
        else if (field instanceof AbstractGroupType) {
            component = new FormGroup$1({}, field.controlOptions);
            ModelHandler.handleModel(field.options.model, (/** @type {?} */ (component)), builderInstance);
        }
        else {
            component = new FormControl$1({ value: null, disabled: field.disabled }, field.controlOptions);
        }
        return component;
    };
    /**
     * @private
     * @param {?} field
     * @param {?} array
     * @param {?} builderInstance
     * @return {?}
     */
    ModelHandler.handleArray = /**
     * @private
     * @param {?} field
     * @param {?} array
     * @param {?} builderInstance
     * @return {?}
     */
    function (field, array, builderInstance) {
        array.push(ModelHandler.handleField(field.fieldInstance, builderInstance));
    };
    return ModelHandler;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: lib/abstract-collection-form-field/abstract-collection-form-field.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @abstract
 */
var  /**
 * @abstract
 */
AbstractCollectionFormFieldComponent = /** @class */ (function (_super) {
    __extends(AbstractCollectionFormFieldComponent, _super);
    function AbstractCollectionFormFieldComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @param {?} index
     * @return {?}
     */
    AbstractCollectionFormFieldComponent.prototype.removeEntry = /**
     * @param {?} index
     * @return {?}
     */
    function (index) {
        ((/** @type {?} */ (this.element))).removeAt(index);
    };
    /**
     * @return {?}
     */
    AbstractCollectionFormFieldComponent.prototype.addEntry = /**
     * @return {?}
     */
    function () {
        if (this.fieldType.fieldInstance instanceof AbstractGroupType) {
            /** @type {?} */
            var field = ModelHandler.build(this.fieldType.fieldInstance.options.model, this.fieldType.builderInstance);
            field.setParent((/** @type {?} */ (this.element)));
            ((/** @type {?} */ (this.element))).controls.push(field);
        }
        else if (this.fieldType.fieldInstance instanceof AbstractCollectionType) {
            ((/** @type {?} */ (this.element))).controls.push(new FormArray$1([], this.fieldType.fieldInstance.controlOptions));
        }
        else {
            ((/** @type {?} */ (this.element))).controls.push(new FormControl$1(null, this.fieldType.fieldInstance.controlOptions));
        }
    };
    return AbstractCollectionFormFieldComponent;
}(AbstractFormFieldComponent));

/**
 * @fileoverview added by tsickle
 * Generated from: lib/abstract-group-form-field/abstract-group-form-field.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @abstract
 * @template FormType
 */
var  /**
 * @abstract
 * @template FormType
 */
AbstractGroupFormField = /** @class */ (function (_super) {
    __extends(AbstractGroupFormField, _super);
    function AbstractGroupFormField() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return AbstractGroupFormField;
}(AbstractFormFieldComponent));

/**
 * @fileoverview added by tsickle
 * Generated from: lib/form-slot/form-slot.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var FormSlotComponent = /** @class */ (function () {
    function FormSlotComponent(viewRef) {
        this.viewRef = viewRef;
    }
    FormSlotComponent.decorators = [
        { type: Component, args: [{
                    selector: 'mw-form-slot',
                    template: ''
                }] }
    ];
    /** @nocollapse */
    FormSlotComponent.ctorParameters = function () { return [
        { type: ViewContainerRef }
    ]; };
    FormSlotComponent.propDecorators = {
        fieldName: [{ type: Input }]
    };
    return FormSlotComponent;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: lib/form-builder/form-builder.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var FormBuilderComponent = /** @class */ (function () {
    function FormBuilderComponent() {
        this.onSubmit = new EventEmitter();
    }
    /**
     * @return {?}
     */
    FormBuilderComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        if (this.group == null) {
            this.rebuildForm();
        }
    };
    /**
     * @param {?} changes
     * @return {?}
     */
    FormBuilderComponent.prototype.ngOnChanges = /**
     * @param {?} changes
     * @return {?}
     */
    function (changes) {
        if ('formModel' in changes && changes.formModel.currentValue) {
            this.rebuildForm();
        }
        if ('formData' in changes && changes.formData.currentValue) {
            if (!('formModel' in changes)) {
                this.initializeCollectionFields(this.group, this.formModel, this.formData);
            }
            if (this.group) {
                this.group.patchValue(this.formData);
            }
        }
    };
    /**
     * @return {?}
     */
    FormBuilderComponent.prototype.rebuildForm = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var res = {};
        if (this.group) {
            res = Object.assign({}, this.group.value);
        }
        else if (this.formData) {
            res = Object.assign({}, this.formData);
        }
        this.group = ModelHandler.build(this.formModel, this);
        this.initializeCollectionFields(this.group, this.formModel, res);
        if (this.group) {
            this.group.patchValue(res);
        }
    };
    /**
     * @private
     * @param {?} group
     * @param {?} model
     * @param {?} data
     * @return {?}
     */
    FormBuilderComponent.prototype.initializeCollectionFields = /**
     * @private
     * @param {?} group
     * @param {?} model
     * @param {?} data
     * @return {?}
     */
    function (group, model, data) {
        var _this = this;
        Object.keys(model).forEach((/**
         * @param {?} name
         * @return {?}
         */
        function (name) {
            /** @type {?} */
            var formType = model[name];
            /** @type {?} */
            var childData = (data && name in data) ? data[name] : null;
            /** @type {?} */
            var control = group.get(name);
            if (formType instanceof AbstractGroupType) {
                _this.initializeCollectionFields((/** @type {?} */ (control)), ((/** @type {?} */ (formType))).options.model, childData);
            }
            else if (formType instanceof AbstractCollectionType) {
                _this.initializeCollectionField(formType, (/** @type {?} */ (control)), childData);
            }
        }));
    };
    /**
     * @private
     * @param {?} collection
     * @param {?} array
     * @param {?=} data
     * @return {?}
     */
    FormBuilderComponent.prototype.initializeCollectionField = /**
     * @private
     * @param {?} collection
     * @param {?} array
     * @param {?=} data
     * @return {?}
     */
    function (collection, array, data) {
        /** @type {?} */
        var numberOfEntries = Array.isArray(data) ? data.length : 0;
        __spread(new Array(array.controls.length).keys()).forEach((/**
         * @param {?} n
         * @return {?}
         */
        function (n) { return array.removeAt(n); }));
        if (numberOfEntries === 0) {
            return;
        }
        /** @type {?} */
        var fieldInstance = collection.fieldInstance;
        /** @type {?} */
        var isGroup = fieldInstance instanceof AbstractGroupType;
        /** @type {?} */
        var isCollection = !isGroup && fieldInstance instanceof AbstractCollectionType;
        /** @type {?} */
        var isFormField = !isCollection && fieldInstance instanceof AbstractType;
        for (var i = 0; i < numberOfEntries; i++) {
            if (isGroup) {
                /** @type {?} */
                var childModel = ((/** @type {?} */ (fieldInstance))).options.model;
                /** @type {?} */
                var childFormGroup = ModelHandler.build(childModel, this);
                childFormGroup.setParent(array);
                if (fieldInstance.disabled) {
                    childFormGroup.disable();
                }
                this.initializeCollectionFields(childFormGroup, childModel, data[i]);
                array.controls.push(childFormGroup);
            }
            else if (isCollection) {
                /** @type {?} */
                var childArray = new FormArray$1([], fieldInstance.controlOptions);
                childArray.setParent(array);
                if (fieldInstance.disabled) {
                    childArray.disable();
                }
                this.initializeCollectionField((/** @type {?} */ (fieldInstance)), childArray, data[i]);
                array.controls.push(childArray);
            }
            else if (isFormField) {
                array.controls.push(new FormControl$1({ value: null, disabled: fieldInstance.disabled }, fieldInstance.controlOptions));
            }
        }
    };
    /**
     * @return {?}
     */
    FormBuilderComponent.prototype.submit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        Object.keys(this.group.controls).forEach((/**
         * @param {?} field
         * @return {?}
         */
        function (field) {
            /** @type {?} */
            var control = _this.group.get(field);
            control.markAsDirty();
            control.updateValueAndValidity();
        }));
        if (!this.group.valid) {
            return;
        }
        this.onSubmit.emit(this.group.value);
        return this.group.value;
    };
    /**
     * @param {?=} group
     * @return {?}
     */
    FormBuilderComponent.prototype.getErrors = /**
     * @param {?=} group
     * @return {?}
     */
    function (group) {
        var _this = this;
        /** @type {?} */
        var errors = group instanceof FormArray$1 ? [] : {};
        if (group == null) {
            group = this.group;
        }
        /** @type {?} */
        var idx = 0;
        Object.keys(group.controls).forEach((/**
         * @param {?} name
         * @return {?}
         */
        function (name) {
            idx++;
            /** @type {?} */
            var control = group.get(name);
            if (control instanceof FormArray$1 || control instanceof FormGroup$1) {
                /** @type {?} */
                var tmpErrors = _this.getErrors((/** @type {?} */ (control)));
                if (tmpErrors) {
                    errors[name] = tmpErrors;
                }
            }
            else if (control instanceof FormControl$1) {
                if (control.errors == null) {
                    return null;
                }
                if (group instanceof FormArray$1) {
                    ((/** @type {?} */ (errors)))[idx] = control.errors;
                }
                else {
                    errors[name] = control.errors;
                }
            }
        }));
        return (group instanceof FormGroup$1 && Object.keys(errors).length === 0)
            || Array.isArray(errors) && errors.length === 0 ? null : errors;
    };
    FormBuilderComponent.decorators = [
        { type: Component, args: [{
                    selector: 'mw-form-builder',
                    template: "\n    <ng-content></ng-content>\n    <form [formGroup]=\"group\" (ngSubmit)=\"submit()\" #form>\n      <mw-form-group #fromGroup [element]=\"group\" [formGroup]=\"group\" [model]=\"formModel\" [slots]=\"slots\" [isRootGroup]=\"true\">\n      </mw-form-group>\n    </form>\n  "
                }] }
    ];
    FormBuilderComponent.propDecorators = {
        formModel: [{ type: Input }],
        formData: [{ type: Input }],
        onSubmit: [{ type: Output }],
        slots: [{ type: ContentChildren, args: [FormSlotComponent, { descendants: true },] }]
    };
    return FormBuilderComponent;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: lib/form-field/form-field.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var FormFieldComponent = /** @class */ (function (_super) {
    __extends(FormFieldComponent, _super);
    function FormFieldComponent(viewRef, cfr) {
        var _this = _super.call(this) || this;
        _this.viewRef = viewRef;
        _this.cfr = cfr;
        return _this;
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    FormFieldComponent.prototype.ngOnChanges = /**
     * @param {?} changes
     * @return {?}
     */
    function (changes) {
        this.render();
    };
    /**
     * @return {?}
     */
    FormFieldComponent.prototype.render = /**
     * @return {?}
     */
    function () {
        if (this.fieldType == null) {
            return;
        }
        this.viewRef.clear();
        /** @type {?} */
        var factory = this.cfr.resolveComponentFactory(this.fieldType.component);
        /** @type {?} */
        var component = this.viewRef.createComponent(factory);
        /** @type {?} */
        var isGroup = this.fieldType instanceof AbstractGroupType;
        ((/** @type {?} */ (component.instance))).formGroup = isGroup ? (/** @type {?} */ (this.element)) : this.formGroup;
        ((/** @type {?} */ (component.instance))).element = this.element;
        ((/** @type {?} */ (component.instance))).fieldType = this.fieldType;
        ((/** @type {?} */ (component.instance))).slots = this.slots;
        ((/** @type {?} */ (component.instance))).path = this.path;
        ((/** @type {?} */ (component.instance))).index = this.index;
        component.changeDetectorRef.detectChanges();
    };
    FormFieldComponent.decorators = [
        { type: Component, args: [{
                    selector: 'mw-form-field',
                    template: ''
                }] }
    ];
    /** @nocollapse */
    FormFieldComponent.ctorParameters = function () { return [
        { type: ViewContainerRef },
        { type: ComponentFactoryResolver }
    ]; };
    return FormFieldComponent;
}(AbstractFormFieldComponent));

/**
 * @fileoverview added by tsickle
 * Generated from: lib/form-group/form-group.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var FormGroupComponent = /** @class */ (function (_super) {
    __extends(FormGroupComponent, _super);
    function FormGroupComponent(cfr, cdr) {
        var _this = _super.call(this) || this;
        _this.cfr = cfr;
        _this.cdr = cdr;
        _this.isRootGroup = false;
        _this.renderTargets = {};
        _this.initializeTimeoutHandle = null;
        _this.orderAsGiven = (/**
         * @return {?}
         */
        function () { return 1; });
        return _this;
    }
    Object.defineProperty(FormGroupComponent.prototype, "groupPath", {
        get: /**
         * @return {?}
         */
        function () {
            return (this.path == null || this.path.trim() === '')
                ? ''
                : this.path;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FormGroupComponent.prototype, "indexFromParent", {
        get: /**
         * @return {?}
         */
        function () {
            if (this.index == null) {
                return null;
            }
            /** @type {?} */
            var p = this.element;
            do {
                p = p.parent;
                if (p instanceof FormArray$1) {
                    return this.index;
                }
            } while (p && p.parent && !(parent instanceof FormControl$1));
            return null;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    FormGroupComponent.prototype.ngAfterViewInit = /**
     * @return {?}
     */
    function () {
        if (this.mySlots) {
            this.renderElementsInSlots();
            this.cdr.detectChanges();
        }
    };
    /**
     * @param {?} changes
     * @return {?}
     */
    FormGroupComponent.prototype.ngOnChanges = /**
     * @param {?} changes
     * @return {?}
     */
    function (changes) {
        /** @type {?} */
        var wasRendered = false;
        if ('slots' in changes && changes.slots.currentValue) {
            this.renderElementsInSlots();
            wasRendered = true;
        }
        if (!wasRendered && 'mySlots' in changes && changes.mySlots.currentValue) {
            this.renderElementsInSlots();
        }
    };
    /**
     * @private
     * @return {?}
     */
    FormGroupComponent.prototype.renderElementsInSlots = /**
     * @private
     * @return {?}
     */
    function () {
        var _this = this;
        if (this.slots || this.mySlots) {
            this.createRenderTargets();
            Object.keys(this.renderTargets).map((/**
             * @param {?} name
             * @return {?}
             */
            function (name) {
                if (!(name in _this.renderTargets)) {
                    return;
                }
                _this.renderTargets[name].viewRef.clear();
                /** @type {?} */
                var factory = _this.cfr.resolveComponentFactory(FormFieldComponent);
                /** @type {?} */
                var target = _this.renderTargets[name].viewRef.createComponent(factory);
                target.instance.formGroup = _this.formGroup;
                target.instance.element = _this.formGroup.get(name);
                target.instance.slots = _this.slots;
                target.instance.path = _this.pathForField(name);
                target.instance.fieldType = _this.model[name];
                target.instance.index = _this.indexFromParent;
                target.instance.render();
            }));
            if (this.isRootGroup) {
                if (this.initializeTimeoutHandle) {
                    window.clearTimeout(this.initializeTimeoutHandle);
                }
                this.initializeTimeoutHandle = window.setTimeout((/**
                 * @return {?}
                 */
                function () {
                    ((/** @type {?} */ (_this.element))).initHandler.setIsInitialized(true);
                    _this.cdr.detectChanges();
                }), 5);
            }
        }
    };
    /**
     * @private
     * @return {?}
     */
    FormGroupComponent.prototype.createRenderTargets = /**
     * @private
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var groupPath = this.groupPath;
        if (this.slots) {
            this.slots.toArray().forEach((/**
             * @param {?} slot
             * @return {?}
             */
            function (slot) {
                if (slot.fieldName.substr(0, groupPath.length) !== groupPath) {
                    return;
                }
                /** @type {?} */
                var name = slot.fieldName.substr(groupPath.length, slot.fieldName.length - groupPath.length);
                if (name.startsWith('.')) {
                    name = name.substr(1);
                }
                if (name.indexOf('.') < 0 && name !== '') {
                    _this.renderTargets[name] = slot;
                }
            }));
        }
        if (this.mySlots) {
            this.mySlots.toArray().forEach((/**
             * @param {?} slot
             * @return {?}
             */
            function (slot) {
                _this.renderTargets[slot.fieldName] = slot;
            }));
        }
    };
    /**
     * @param {?} fieldName
     * @return {?}
     */
    FormGroupComponent.prototype.pathForField = /**
     * @param {?} fieldName
     * @return {?}
     */
    function (fieldName) {
        return (this.groupPath === '')
            ? fieldName
            : this.path + '.' + fieldName;
    };
    FormGroupComponent.decorators = [
        { type: Component, args: [{
                    selector: 'mw-form-group',
                    template: "\n    <ng-content></ng-content>\n    <ng-container *ngFor=\"let field of (model | keyvalue:orderAsGiven)\">\n      <mw-form-field *ngIf=\"renderTargets[field.key] == null\"\n                     [formGroup]=\"element\"\n                     [element]=\"element.get(field.key)\"\n                     [fieldType]=\"field.value\"\n                     [path]=\"pathForField(field.key)\"\n                     [index]=\"indexFromParent\"\n                     [slots]=\"slots\">\n      </mw-form-field>\n    </ng-container>\n  "
                }] }
    ];
    /** @nocollapse */
    FormGroupComponent.ctorParameters = function () { return [
        { type: ComponentFactoryResolver },
        { type: ChangeDetectorRef }
    ]; };
    FormGroupComponent.propDecorators = {
        isRootGroup: [{ type: Input }],
        model: [{ type: Input }],
        mySlots: [{ type: ContentChildren, args: [FormSlotComponent, { descendants: true },] }]
    };
    return FormGroupComponent;
}(AbstractFormFieldComponent));

/**
 * @fileoverview added by tsickle
 * Generated from: lib/form-builder.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var FormBuilderModule = /** @class */ (function () {
    function FormBuilderModule() {
    }
    FormBuilderModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [
                        FormBuilderComponent,
                        FormGroupComponent,
                        FormFieldComponent,
                        FormSlotComponent,
                    ],
                    entryComponents: [
                        FormFieldComponent,
                        FormGroupComponent,
                    ],
                    imports: [
                        ReactiveFormsModule,
                        CommonModule,
                    ],
                    exports: [
                        FormBuilderComponent,
                        FormGroupComponent,
                        FormFieldComponent,
                        FormSlotComponent,
                    ],
                },] }
    ];
    return FormBuilderModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: mw-form-builder.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { AbstractCollectionFormFieldComponent, AbstractFormFieldComponent, AbstractGroupFormField, FormBuilderComponent, FormFieldComponent, FormSlotComponent, FormBuilderModule, AbstractType, AbstractGroupType, AbstractCollectionType, FormGroupComponent as ɵa };

//# sourceMappingURL=mw-form-builder.js.map