import { EventEmitter, OnChanges, OnInit, QueryList, SimpleChanges } from '@angular/core';
import { ValidationErrors } from '@angular/forms';
import { AbstractType } from '../form-type/abstract-type';
import { FormSlotComponent } from '../form-slot/form-slot.component';
import { FormArray, FormGroup } from '../abstraction';
export interface FormModel {
    [key: string]: AbstractType<any>;
}
export declare class FormBuilderComponent implements OnInit, OnChanges {
    formModel: FormModel;
    formData: {
        [key: string]: any;
    };
    onSubmit: EventEmitter<any>;
    slots: QueryList<FormSlotComponent>;
    group: FormGroup;
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    rebuildForm(): void;
    private initializeCollectionFields;
    private initializeCollectionField;
    submit(): any;
    getErrors(group?: FormGroup | FormArray): {
        [key: string]: ValidationErrors;
    } | ValidationErrors[] | null;
}
